#!/bin/sh
# $Id: mplayer-lib.sh,v 1.1.1.1.2.2 2006/04/19 14:22:43 eugen Exp $

# Contains:
#
# mplayer_brightness_up		[1]
# mplayer_brightness_down	[1]
# mplayer_fullscreen
# mplayer_mute
# mplayer_pause_still
# mplayer_play
# mplayer_quit
# mplayer_ratio
# mplayer_rewind_stop
# mplayer_speed_normal		[2]
# mplayer_speed_up		[2]
# mplayer_stop
# mplayer_seek
# mplayer_use_master		[3]
# mplayer_use_pcm		[3]
# mplayer_volume
# mplayer_window
#
# NOTES:
# At present (MPlayer 1.0pre7try2) there are some glitches.
#
# 1. Brightness control works not for all video output drivers.
# 2. Change of playback speed may break audio - do not use.
# 3. Volume control switching (PCM/master) doesn't work.

# State initialization
mplayer_state=playing
mplayer_speed=normal
mplayer_vol_ch=pcm
mplayer_fullscr=no
mplayer_brightness=0

mplayer_brightness_up() {
  if [ $mplayer_brightness -le 99 ]; then
    mplayer_brightness=$(($mplayer_brightness + 1 ))
    echo brightness $mplayer_brightness
    [ $mplayer_state != playing ] && echo pause
  fi
}

mplayer_brightness_down() {
  if [ $mplayer_brightness -ge -99 ]; then
    mplayer_brightness=$(($mplayer_brightness - 1 ))
    echo brightness $mplayer_brightness
    [ $mplayer_state != playing ] && echo pause
  fi
}

mplayer_fullscreen() {
  [ $mplayer_fullscr = no ] && echo vo_fullscreen && mplayer_fullscr=yes
  mplayer_state=playing
}

mplayer_mute() {
  echo mute
  [ $mplayer_state != playing ] && echo pause
}

mplayer_pause_still() {
  if [ $mplayer_state = playing ]; then
    mplayer_state=pause
    echo pause
  else
    if [ $mplayer_state = pause ]; then
      echo frame_step
    fi
  fi
}

mplayer_play() {
  if [ $mplayer_state != playing ]; then
    mplayer_state=playing
    echo pause
  fi
}

mplayer_quit() {
  echo quit 0
  exit
}

mplayer_ratio() {
  echo switch_ratio $1
  [ $mplayer_fullscr = yes ] && echo vo_fullscreen
  [ $mplayer_state != playing ] && echo pause
}

mplayer_rewind_stop() {
  echo speed_set 1
  echo seek 0 2
  echo frame_step
  echo pause
  mplayer_state=idle
  mplayer_speed=normal
}

mplayer_speed_normal() {
  echo speed_set 1
  [ $mplayer_state != playing ] && echo pause
  mplayer_speed=normal
}

mplayer_speed_up() {
  if [ $mplayer_state != playing ]; then
    echo speed_set 1
    mplayer_state=playing
  fi
  echo speed_mult 2
  mplayer_speed=quick
}

mplayer_stop() {
  [ $mplayer_speed = normal ] || echo speed_set 1
  [ $mplayer_state = playing ] && echo pause
  mplayer_speed=normal
  mplayer_state=idle
}

mplayer_seek() {
  echo seek $1 $2
  mplayer_state=playing
}

mplayer_use_master() {
  if [ $mplayer_vol_ch = pcm ]; then
    echo use_master
    mplayer_vol_ch=master
    [ $mplayer_state != playing ] && echo pause
  fi
}

mplayer_use_pcm() {
  if [ $mplayer_vol_ch = master ]; then
    echo use_master
    mplayer_vol_ch=pcm
    [ $mplayer_state != playing ] && echo pause
  fi
}

mplayer_volume() {
  echo volume $1
  [ $mplayer_state != playing ] && echo pause
}

mplayer_window() {
  [ $mplayer_fullscr = yes ] && echo vo_fullscreen && mplayer_fullscr=no && \
    mplayer_state=playing
}
